#include <v8.h>
#include <node.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <ctype.h>
#include "libstemmer/include/libstemmer.h"

#define LIMIT 12

using namespace v8;
using namespace node;

Handle<Value> StemEn(const Arguments& args) {
    if (!args[0]->IsString())
        return Boolean::New(false);

    //Get the word
    const sb_symbol * to_stem = (sb_symbol *) malloc(LIMIT * sizeof(sb_symbol));
    args[0]->ToString()->WriteUtf8((char *)to_stem);

    //Stem the word
    sb_stemmer *stemmer = sb_stemmer_new("en", NULL);
    const sb_symbol *stemmed = sb_stemmer_stem(stemmer, to_stem, strlen((char *)to_stem));
    Local<String> result = String::New((char *) stemmed);
    sb_stemmer_delete(stemmer);

    return result;
}

extern "C" void init(Handle<Object> target) {
  HandleScope scope;
  NODE_SET_METHOD(target, "stem", StemEn);
}
